#include <bits/stdc++.h>

using namespace std;

const int maxn=(int)1e3+5;
int a[3*maxn][3*maxn],n,m,Ans,ans[3*maxn][3*maxn];
string s[maxn];

bool check(int x,int y)
{
    if(a[x][y]==a[x+1][y]&&a[x][y]==a[x][y+1]&&a[x][y]==a[x+1][y+1]) return true;
    return false;
}

int update1(int x,int y)
{
    int answer=0;
    for(int i=y;i<y+m-1;i++)
        if(check(x-1,i)) answer--;
    for(int i=y;i<y+m-1;i++)
        if(check(x+n-2,i)) answer++;
    return answer;
}

int update2(int x,int y)
{
    int answer=0;
    for(int i=x;i<x+n-1;i++)
        if(check(i,y-1)) answer--;
    for(int i=x;i<x+n-1;i++)
        if(check(i,y+m-2)) answer++;
    return answer;
}

int f(int x,int y)
{
    int answer=0;
    for(int i=x;i<x+n-1;i++)
        for(int j=y;j<y+m-1;j++)
            if(check(i,j)) answer++;
    return answer;
}

int main()
{
    freopen("video.in","r",stdin);
    freopen("video.out","w",stdout);
    cin >> n >> m;
    for(int i=0;i<n;i++)
        cin >> s[i];
    for(int i=n;i<2*n;i++)
        for(int j=m;j<2*m;j++)
            a[i][j]=s[i-n][j-m]-'0';
    for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
            a[i][j]=a[i+n][j+m];
    for(int i=n;i<2*n;i++)
        for(int j=0;j<m;j++)
            a[i][j]=a[i][j+m];
    for(int i=0;i<n;i++)
        for(int j=m;j<2*m;j++)
            a[i][j]=a[i+n][j];
    for(int i=2*n;i<3*n;i++)
        for(int j=0;j<m;j++)
            a[i][j]=a[i-n][j];
    for(int i=2*n;i<3*n;i++)
        for(int j=m;j<2*m;j++)
            a[i][j]=a[i-n][j];
    for(int i=2*n;i<3*n;i++)
        for(int j=2*m;j<3*m;j++)
            a[i][j]=a[i][j-m];
    for(int i=n;i<2*n;i++)
        for(int j=2*m;j<3*m;j++)
            a[i][j]=a[i][j-m];
    for(int i=0;i<n;i++)
        for(int j=2*m;j<3*m;j++)
            a[i][j]=a[i][j-m];
    for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
        {
            if(i==0&&j==0) ans[i][j]=f(0,0);
            if(i>0) ans[i][j]=ans[i-1][j]+update1(i,j);
            if(i==0&&j!=0) ans[i][j]=ans[i][j-1]+update2(i,j);
            Ans=max(Ans,ans[i][j]);
        }
    cout << Ans;
    return 0;
}
